/*
 * main.c
 *
 *  Created on: 16.02.2017
 *      Author: Michal
 */
#include <avr/io.h>
#include <avr/interrupt.h>

#define adress_w 0xA0
#define adress_r 0xA1

const uint8_t anoda[4] = {0b0001,0b0010,0b0100,0b1000};
const uint16_t cyfra[10] = {0b1000000000,0b1,0b10,0b100,0b1000,0b10000,0b100000
		,0b1000000,0b10000000,0b100000000};

uint8_t dz_godzin=0, j_godzin=0, dz_minut=0, j_minut=0,i=0,minuty=0,godziny=0,pom=0;

// funkcje opozniajace - potrzebne przy obsludze przycisku i tranmisji I2C

void wait(void)
{
	volatile uint8_t x,y;

	for(x=0;x<40;x++)
	{
		for(y=0;y<10;y++)
		{

		}
	}
}

void wait2(void)
{
	volatile uint8_t x,y;

	for(x=0;x<200;x++)
	{
		for(y=0;y<200;y++)
		{

		}
	}
}

// funkcje obslugi magistrali I2C oraz zapisywania i odczytywania czasu do RTC za jej porednictwem

void send_start_cond(void)
{
	TWCR = (1<<TWSTA)| (1<<TWINT)|(1<<TWEN); 
	while(!(TWCR & (1<<TWINT)));
	while((TWSR & 0xF8)!=0x08);
}

void send_restart_cond(void)
{
	TWCR = (1<<TWSTA)| (1<<TWINT)|(1<<TWEN);
	while(!(TWCR & (1<<TWINT)));
	while((TWSR & 0xF8)!=0x10);
}



void send_data(uint8_t data)
{
	TWDR = data;
	TWCR = (1<<TWINT) | (1<<TWEN);
	while (!(TWCR & (1<<TWINT)));
	while((TWSR & 0xF8)!=0x28);

}

void send_adress_w(uint8_t addr)
{
	TWDR = addr;
	TWCR = (1<<TWINT) | (1<<TWEN);
	while (!(TWCR & (1<<TWINT)));
	while((TWSR & 0xF8)!=0x18);

}


void send_adress_r(uint8_t addr)
{
	TWDR = addr;
	TWCR = (1<<TWINT) | (1<<TWEN);
	while (!(TWCR & (1<<TWINT)));
	while((TWSR & 0xF8)!=0x40);

}

void send_stop_cond()
{
	TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTO); //stop
	wait();

}


uint8_t get_data(uint8_t reg_addr)// MSB
{
	uint8_t value=0;


	send_start_cond();

	send_adress_w((uint8_t)(adress_w));
	send_data(reg_addr);


	send_restart_cond();
	send_adress_r(adress_r);

	TWCR = (1<<TWINT) | (1<<TWEN);
	while (!(TWCR & (1<<TWINT)));
	while((TWSR & 0xF8)!=0x58);
	value = TWDR;
	send_stop_cond();


	return value;
}
void stop_counting(void)
{
send_start_cond();
send_adress_w(adress_w);
send_data(0x00); //control_register
send_data(0x80); // stop counting
send_stop_cond();
}

void start_counting(void)
{
send_start_cond();
send_adress_w(adress_w);
send_data(0x00); //control_register
send_data(0x00); // stop counting
send_stop_cond();
}

void set_minutes(uint8_t minutes)
{
	send_start_cond();
	send_adress_w(adress_w);
	send_data(0x03);// minutes register
	send_data(((minutes/10)<<4)|(minutes%10)); //set minutes (bcd)
	send_stop_cond();
}

void set_hours(uint8_t hours)
{
	send_start_cond();
	send_adress_w(adress_w);
	send_data(0x04);// hours register
	send_data((0b00111111)&(((hours/10)<<4)|(hours%10))); //set hours (bcd)
	send_stop_cond();
}


ISR(TIMER2_OVF_vect) // przerwanie od licznika 0 - multipleksowanie i wywietlanie czasu
{

if(pom==5)
{
	pom=0;
	if(i==0)
	{

		PORTC &= 0xf0;
		PORTC &= 0xf0;
		PORTD = (uint8_t)((0x00ff)&(cyfra[j_minut]));
		PORTB = (uint8_t)((0b11000000)|((((0xff00)&(cyfra[j_minut]))>>8)));
		PORTC |= (0xf0|anoda[3]);

	}
	if(i==1)
	{

		PORTC &= 0xf0;
				PORTC &= 0xf0;
		PORTD = (uint8_t)((0x00ff)&(cyfra[dz_minut]));
		PORTB = (uint8_t)((0b11000000)|((((0xff00)&(cyfra[dz_minut]))>>8)));
		PORTC |= (0xf0|anoda[2]);
	}
	if(i==2)
	{

		PORTC &= 0xf0;
				PORTC &= 0xf0;
		PORTD = (uint8_t)((0x00ff)&(cyfra[j_godzin]));
		PORTB = (uint8_t)((0b11000000)|((((0xff00)&(cyfra[j_godzin]))>>8)));
		PORTC &= 0xf0;
		PORTC |= (0xf0|anoda[1]);
	}
	if(i==3)
	{


				PORTC &= 0xf0;
				PORTC &= 0xf0;
		if(dz_godzin>0)
		{
		PORTD = (uint8_t)((0x00ff)&(cyfra[dz_godzin]));
		PORTB = (uint8_t)((0b11000000)|((((0xff00)&(cyfra[dz_godzin]))>>8)));
		PORTC |= (0xf0|anoda[0]);
		}


	}
	i++;
	if(i==4)
	i=0;
}
else
pom++;
}

// przerwanie od timera 1 - odczytanie aktualnego czasu i zapisanie go w pamici
ISR(TIMER1_OVF_vect)
{
	sei();
	godziny=get_data(0x04);//godziny
	j_godzin = ((0x0f)&(godziny));
	dz_godzin = (((0b00111111)&(godziny))>>4);
	godziny = j_godzin + 10*dz_godzin;


	minuty=get_data(0x03);//minuty
	j_minut = ((0x0f)&(minuty));
	dz_minut = (minuty>>4);
	minuty = j_minut+10*dz_minut;
}

int main(void)
{
uint8_t g_m =0;


for(uint8_t i =0;i<20;i++)
{
	wait2();
}



// inicjalizacja portw we/wy
DDRD = 0xff;
DDRC =  (1<<PC0)|(1<<PC1)|(1<<PC2)|(1<<PC3);
DDRB |= (1<<PB0)|(1<<PB1);


// inicjalizacja timera2 - multiplekowanie
TCCR2 |= (1<<CS21);
TIMSK |= (1<<TOIE2); // interr. en

// inicjalizacja timera1 - do odczytywania czasu co okoo 4s
TCCR1B |= (1<<CS12);
TIMSK |= (1<<TOIE1);


// inicjalizacja i2c
TWBR = 6;

//po ponownym uruchomieniu systemu odczytanie aktualnego czasu z RTC 

godziny=get_data(0x04);//godziny
j_godzin = ((0x0f)&(godziny));
dz_godzin = (((0b00111111)&(godziny))>>4);
godziny = j_godzin + 10*dz_godzin;

minuty=get_data(0x03);//minuty
j_minut = ((0x0f)&(minuty));
dz_minut = (minuty>>4);
minuty = j_minut+10*dz_minut;

sei();


	while(1)
	{

// obsluga przycisku
		if(!(PINB&0b00000100))
		{
			wait2();

				if(!g_m)
				{
					minuty++;
						if(minuty==60)
						{
							g_m=1;
							minuty=0;
						}
				}

				else
				{
					wait2();
					godziny++;
						if(godziny==24)
							godziny=0;
				}
				
		// zapisanie ustawionj godziny do RTC  

		stop_counting();
		set_minutes(minuty);
		set_hours(godziny);
		start_counting();

		j_minut = minuty%10;
		dz_minut = minuty/10;

		j_godzin = godziny%10;
		dz_godzin = godziny/10;

		}

		else
		{
			g_m = 0;
		}


	}
}

